"use strict";Object.defineProperty(exports, "__esModule", {value: true});// src/index.ts







var _language = require('@codemirror/language');
var _highlight = require('@lezer/highlight');

// esbuild-plugin-lezer:/Users/nvie/Projects/liveblocks/liveblocks-schema/packages/codemirror-language/src/syntax.grammar
var _lr = require('@lezer/lr');
var spec_name = { __proto__: null, type: 10 };
var parser = _lr.LRParser.deserialize({
  version: 14,
  states: "&fOYQPOOO_QQO'#C_QYQPOOOOQO'#C`'#C`OOQO'#Co'#CoOOQO'#Cb'#CbOdQPO,58yOOQO-E6m-E6mOlQPO'#CyOOQO'#Cc'#CcOOQO1G.e1G.eOqQPO1G.eOOQO'#Cf'#CfOvQPO'#CeOOQO'#Cp'#CpO!OQPO,59eOOQO7+$P7+$PO!WQQO,59PO!`QPO,59POOQO-E6n-E6nOOQO1G/P1G/POOQO'#Ci'#CiO!eQPO'#ChOOQO'#Ch'#ChO!vQPO1G.kO!WQQO1G.kO!WQQO,59VOOQO'#Cr'#CrO#RQPO,59XOOQO7+$V7+$VO#aQPO7+$VO#lQQO'#C{O#tQQO'#ChO$SQPO1G.qOOQO-E6p-E6pOOQO<<Gq<<GqO!WQQO'#CqO$XQQO,59gO$aQQO,59XOOQO7+$]7+$]OOQO,59],59]OOQO-E6o-E6o",
  stateData: "$l~OiOSPOS~OTRO~OkTO~OWWOlZO~Oj[O~OWWO~OZaOnbO~ObdOj[O~OWWOkeO~OZiO~O`jOqkOb[Xj[Xr[X~OrmObXijXi~OqkObaajaaraa~OrsObXqjXq~OptO^oX~O`jOqkO^[Xp[X~O^wO~OptO^oa~OqkO^aapaa~O",
  goto: "#opPPPquPy|P!Y!^P!b!nP!SP!SP!v!|#S#YPPPPPP#dP#lTSOQTPOQRUPQYUQ`ZXgaijtT^W_T]W_QhaQniQojRxtSfaiTpjtQQORVQQ_WRc_QuoRyuQlfSrlvRvp]XUZaijtRqj",
  nodeNames: "\u26A0 Comment Document ObjectTypeDefinition TypeKeyword type NamedTypeDeclaration FieldsDefinition { ValueDefinition Name : Type NamedType > GenericType < ArrayType }",
  maxTerm: 34,
  skippedNodes: [0, 1],
  repeatNodeCount: 4,
  tokenData: "&U~RiX^!ppq!pst#e|}#|!P!Q$T![!]$Z!]!^$`!^!_$e!_!`$j!`!a$o!a!b$t!c!}$y!}#O%^#R#S$y#T#o%i#o#p%z#q#r&P#y#z!p$f$g!p#BY#BZ!p$IS$I_!p$I|$JO!p$JT$JU!p$KV$KW!p&FU&FV!p~!uYi~X^!ppq!p#y#z!p$f$g!p#BY#BZ!p$IS$I_!p$I|$JO!p$JT$JU!p$KV$KW!p&FU&FV!p~#jSP~OY#eZ;'S#e;'S;=`#v<%lO#e~#yP;=`<%l#eR$TOpQrP~$WP!P!Q#e~$`OZ~P$eOrP~$jO`~~$oOl~~$tO^~~$yOn~R%QSkQjP!Q![$y!c!}$y#R#S$y#T#o$y~%aP#P#Q%d~%iOq~P%nSjP!Q![%i!c!}%i#R#S%i#T#o%i~&POW~~&UOb~",
  tokenizers: [0, 1],
  topRules: { "Document": [0, 2] },
  specialized: [{ term: 26, get: (value) => spec_name[value] || -1 }],
  tokenPrec: 0
});

// src/linter.ts
var _lint = require('@codemirror/lint');
var _schema = require('@liveblocks/schema');
var linter = _lint.linter.call(void 0, 
  (view) => {
    const code = view.state.doc.toString();
    const diagnostics = _schema.getDiagnostics.call(void 0, code).map((diagnostic) => {
      var _a;
      return {
        from: diagnostic.range[0].offset,
        to: diagnostic.range[1].offset,
        message: diagnostic.message,
        severity: diagnostic.severity,
        actions: (_a = diagnostic.suggestions) == null ? void 0 : _a.map((suggestion) => {
          if (suggestion.type === "replace") {
            return {
              name: "Replace",
              apply: (view2, from, to) => {
                view2.dispatch({
                  changes: { from, to, insert: suggestion.name }
                });
              }
            };
          } else if (suggestion.type === "add-object-type-def") {
            return {
              name: "Add definition",
              apply: (view2) => {
                const insert = `

type ${suggestion.name} {
  
}
`;
                const to = code.length;
                const from = code.trimEnd().length;
                view2.dispatch({
                  changes: {
                    from: to,
                    insert
                  },
                  selection: { anchor: from + insert.length - 3 }
                });
              }
            };
          } else {
            return;
          }
        }).filter(Boolean)
      };
    });
    return diagnostics;
  },
  { delay: 200 }
);

// src/index.ts
var parentheses = "( )";
var braces = "{ }";
var angleBrackets = "< >";
var punctuations = `${parentheses} ${braces} ${angleBrackets} : = ?`;
var blocks = `FieldsDefinition ${braces}`;
var generic = `GenericType ${angleBrackets}`;
var LiveblocksSchema = _language.LRLanguage.define({
  name: "liveblocks-schema",
  parser: parser.configure({
    props: [
      _language.indentNodeProp.add({
        [blocks]: _language.delimitedIndent.call(void 0, { closing: "}", align: true })
      }),
      _language.indentNodeProp.add({
        [generic]: _language.delimitedIndent.call(void 0, { closing: ">", align: false })
      }),
      _language.foldNodeProp.add({
        [blocks]: _language.foldInside
      }),
      _highlight.styleTags.call(void 0, {
        Comment: _highlight.tags.lineComment,
        Name: _highlight.tags.name,
        NamedType: _highlight.tags.typeName,
        GenericType: _highlight.tags.special(_highlight.tags.typeName),
        NamedTypeDeclaration: _highlight.tags.variableName,
        type: _highlight.tags.keyword,
        separator: _highlight.tags.separator,
        comma: _highlight.tags.separator,
        [parentheses]: _highlight.tags.paren,
        [braces]: _highlight.tags.brace,
        [angleBrackets]: _highlight.tags.angleBracket,
        [punctuations]: _highlight.tags.punctuation
      })
    ]
  }),
  languageData: {
    commentTokens: { line: "#" },
    closeBrackets: { brackets: ["{", "<", "[", '"'] },
    indentOnInput: /^\s*(\{|\})$/
  }
});
function liveblocksSchema() {
  return new (0, _language.LanguageSupport)(LiveblocksSchema);
}




exports.LiveblocksSchema = LiveblocksSchema; exports.linter = linter; exports.liveblocksSchema = liveblocksSchema;
